
#include <stdarg.h>


int sscanf(const char *src, const char *fmt, ...)
{
  va_list arglist;
  char *carg;
  unsigned int uval, base, ovfl, ovfl2;
  int *narg, wast, ac, width, ch, cnv, sign;

  va_start(arglist, fmt);

  ac = 0;

  while(*fmt)
  {
    if(isspace(*fmt)) {fmt++; continue;}

    if(*fmt++ != '%') continue;

    if(*fmt == '*')
    {
       narg = &wast;
       carg = (char *)narg;
       fmt++;
    }
    else
    {
       narg = va_arg(arglist, int*);
       carg = (char *)narg;
    }

    fmt += utoi(fmt, &width);

    if(!width) width = 32767;
    if(!(cnv = *fmt++)) break;

    while(isspace(ch = *src++)) ;

    if(!ch) break;
    src--;

    switch(cnv)
    {
      case 'c':
        *carg = *src++;
        break;

      case 's':
        while(width--)
        {
          if((*carg = *src++) == 0) break;
          if(isspace(*carg)) break;
          if(carg != (char *)&wast) carg++;
        }
        *carg = 0;
        break;

      default:

		sign = 1;
		
        switch(cnv)
        {
          case 'b': base =  2; ovfl = 32767; break;
          case 'd': base = 10; ovfl = 3276; sign = 0; break;
          case 'o': base =  8; ovfl = 8191; break;
          case 'u': base = 10; ovfl = 6553; break;
          case 'x': base = 16; ovfl = 4095; break;
          default:  return (ac);
        }

		ovfl2 = sign ? 65535 : 32767;
        
        *narg = uval = 0;

        while(width-- && !isspace(ch = *src++) && (ch != 0))
        {
          if(!sign)
          {
            if(ch == '-')
            {
              sign = -1;
              ovfl2++;
              continue;
            }
            else sign = 1;
          }

          if(ch < '0') return (ac);

          if(ch >= 'a')      ch -= 87;
          else if(ch >= 'A') ch -= 55;
          else               ch -= '0';

          if((ch >= base) || (uval > ovfl)) return (ac);

          uval *= base;

          if((uval > (ovfl2 - ch))) return (ac);

          uval += ch;
          
        }
        
        *narg = sign * uval;
    }
    ac++;                          
  }

  va_end(arglist);
  return (ac);
}


