

void cout(const char ch);
void puts(const char *str);

int isspace(char ch);
int isdigit(char ch);
int atoi(const char *str);

void cursor(const char cursor_on);
unsigned char key_avail();
unsigned char read_keybuf();
unsigned char read_keyflags();

void getline(char *str);

void abort() __attribute__((naked));

//void printf(const char *fmtstr, ...);

#include "printf.c"
#include "sscanf.c"

unsigned int randnum;

int main()
{
//   char *inport0 = (char *)0xff50;
//   char *inport1 = (char *)0xff58;

  
   char str[81];
   unsigned int mynum, ac, guess;
   
   puts(__FILE__" "__DATE__" "__TIME__"\r\n");

   mynum = 0;
   
   while(1)
   {
		getline(str);

		if(!mynum) mynum = (randnum % 100) + 1;
		
		ac = sscanf(str, "%u", &guess);
		
		if(ac)
		{
			if(guess > mynum)
			{
				puts("Too high!\r\n");
			}
			else if(guess < mynum)
			{
				puts("Too low!\r\n");
			}
			else
			{
				puts("Correct!\r\n");
				mynum = 0;
			}
		}
		else
		{
			if(str[0] == 'q') break;
			
			puts("?\r\n");
		}

		//printf(">%d, %d\r\n", ac, i);
   }


   return 0;
}



void getline(char *str)
{
	char *ptr = str;
	unsigned char ch;
	int done = 0;
	
	while(!done)
	{

		while(!key_avail())
   		{
			randnum++;
   		}
   		
   		ch = read_keybuf();
   		{
			if((ch >=0x20) && (ch <= 0x7f))
			{
				*ptr++ = ch;
				cout(ch);
			}
			else switch(ch)
			{
				case 8:
				if(ptr > str)
				{
					ptr--;
					puts("\b \b");
				}
				break;
				
				case 13:
				{
					*ptr++ = '\n';
					*ptr = '\0';
					cout(13); cout(10);
					done = 1;
				}
			}

		}
	}

}


void puts(const char *str)
{
  while(*str) cout(*str++);
}


void cout(const char ch)
{
   asm(
   		"tfr b,a\n\t"
   		"jsr 0xf009"
       	:
       	: "d" (ch)
       );
}



int isspace(char ch)
{
	return (ch == ' ') || ((ch >= 9) && (ch <= 13));
}

int isdigit(char ch)
{
	return ((ch >= '0') && (ch <= '9'));
}


int atoi(const char *str)
{
  int sign, n;
  
  while(isspace(*str)) ++str;

  sign = 0;

  switch(*str)
  {
    case '-': sign = 1;
    case '+': ++str;
  }
  
  n = 0;

  while(isdigit(*str)) n = 10 * n + *str++ - '0';

  return (sign ? -n : n);
}


unsigned char key_avail()
{
   unsigned char ch;

   // The volatile keyword tells the compiler that the result of this code
   // can change. Otherwise it could be optimised out of loops.
   asm volatile(
   		"jsr 0xf000\n\t"
   		"tfr cc,b\n\t"
   		"comb\n\t"
   		"andb #4"
       	: "=d" (ch)
       );

   return ch;
}

unsigned char read_keybuf()
{
   unsigned char ch;

   // The volatile keyword tells the compiler that the result of this code
   // can change. Otherwise it could be optimised out of loops.
   asm volatile(
   		"jsr 0xf003\n\t"
   		"tfr a,b"
       	: "=d" (ch)
       );

   return ch;
}

unsigned char read_keyflags()
{
   unsigned char ch;

   // The volatile keyword tells the compiler that the result of this code
   // can change. Otherwise it could be optimised out of loops.
   asm volatile(
   		"jsr 0xf006\n\t"
   		"tfr a,b"
       	: "=d" (ch)
       );

   return ch;
}


void abort()
{
   puts("\rABNORMAL EXIT\r");
   asm("lds __initstk");
   asm("rts");
}

